#!/usr/bin/env python

__version__ = '0.0.1'

from wxPython.wx import *
from App import *
from tempfile import mktemp
import ftplib
import string
import os

# your favorite editor
EDITOR_CMD = 'xjed %s -l ./test.sl'
# host port username password
LOGIN_CMD = 'localhost 8021 admin yourpassword'

test_menu = """<?xml version="1.0"?>
<wxappdef title="ZopeEDIT" wide="400" high="300" statusbar="default">
  <menudef>
    <menu name="&File">
       <menuitem name="&Open" accel="Ctrl-O" id="1001" tip="Open this up" />
       <menuitem name="&New" accel="Ctrl-N" id="1002" tip="Open this up" />
       <menuitem name="&Save" accel="Ctrl-S" id="1003" tip="Open this up" />
       <menuitem name="Save &As..." accel="Ctrl-A" id="1004" tip="Open this up" />
       <menuseparator />
       <menuitem name="E&xit" accel="Ctrl-X" id="1005" />
    </menu>
    <menu name="&Edit">
       <menuitem name="Copy" accel="Alt-C" id="2001" />
       <menuitem name="Cut" accel="Alt-X"  id="2002"/>
       <menuitem name="Paste" accel="Alt-V" id="2003" />
    </menu>
  </menudef>
  <toolbar>
    <toolbaritem name="Open" bitmap="Open" id="1001" tip="Open this up" />
    <toolbaritem name="New" bitmap="Open" id="1002" tip="Open this up" />
    <toolbaritem name="Save" bitmap="Open" id="1003" tip="Open this up" />
    <toolbaritem name="Save As" bitmap="Open" id="1004" tip="Open this up" />
    <toolbarseparator />
    <toolbaritem name="Copy" bitmap="Copy" id="2001" />
    <toolbaritem name="Cut" bitmap="Cut" id="2002"/>
    <toolbaritem name="Paste" bitmap="Paste" id="2003" />
  </toolbar>
</wxappdef>
"""

# ========================================================================
class wxFTP( App ):
    def __init__( self, resource ):
	self._ftp = ftplib.FTP()
	self._root = None
	
	App.__init__( self, resource )
	splitter = wxSplitterWindow( self, -1 )
	tID = wxNewId()
	self.tree = wxTreeCtrl( splitter, tID )
	EVT_TREE_ITEM_EXPANDED( self.tree, tID, self.OnItemExpanded )
	EVT_TREE_ITEM_COLLAPSED( self.tree, tID, self.OnItemCollapsed )
	EVT_TREE_SEL_CHANGED( self.tree, tID, self.OnTreeSelChanged )
	
	listID = wxNewId()
	self.flist = wxListBox( splitter, listID, wxDefaultPosition, wxDefaultSize, [], wxLB_SINGLE )
	EVT_LISTBOX_DCLICK( self.flist, listID, self.OnListDClick )
	
	splitter.SplitVertically( self.tree, self.flist )
	splitter.SetSashPosition( 180, true )
	splitter.SetMinimumPaneSize( 20 )
	
    # --------------------------------------------------------------------
    def OnListDClick( self, event ):
	sel = self.flist.GetSelection()
	fname = self.flist.GetString( sel )
	tmpfile = mktemp()
	self._fp = open( tmpfile, 'w' )
	try:
	    self._ftp.retrbinary( 'RETR %s' % fname, self.saveFile )
	    self._fp.close()
	    os.system( EDITOR_CMD % tmpfile )
	    dlg = wxMessageDialog( self, 'Save to Zope?', 'Save', wxYES_NO | wxICON_QUESTION )
	    if dlg.ShowModal() == wxID_YES:
		self._fp = open( tmpfile, 'r' )
		self._ftp.storbinary( 'STOR %s' % fname, self._fp, 8192 )
		self._fp.close()
	    dlg.Destroy()
	except ftplib.error_perm, msg:
	    dlg = wxMessageDialog( self, msg, 'FTP Error', wxOK | wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()
	
    # --------------------------------------------------------------------
    def saveFile( self, data ):
	self._fp.write( data )
	
    # --------------------------------------------------------------------
    def OnItemExpanded( self, event ):
	item = event.GetItem()
	
    # --------------------------------------------------------------------
    def OnItemCollapsed( self, event ):
	item = event.GetItem()
	
    # --------------------------------------------------------------------
    def OnTreeSelChanged( self, event ):
	item = event.GetItem()
	parent = self.tree.GetItemParent( item )
	path = '/' 
	if self.tree.GetItemText(item) != '/':
	    path = path + self.tree.GetItemText(item)
	while len(self.tree.GetItemText(parent)):
	    path = '/' + self.tree.GetItemText(parent) + path
	    parent = self.tree.GetItemParent( parent )
	self.tree.CollapseAndReset( item )
	self._curdir = item
	self.getFileList( path )
	
    # --------------------------------------------------------------------
    def OnOpen( self, event ):
	dlg = wxTextEntryDialog( self, 'Connect to:', 'Connect', LOGIN_CMD )
	if dlg.ShowModal() == wxID_OK:
	    vals = string.split( dlg.GetValue() )
	    self._ftp.connect( vals[0], int(vals[1]))
	    self._ftp.login( vals[2], vals[3] )
	    self.flist.Clear()
	    self.tree.DeleteAllItems()
	    self._root = self.tree.AddRoot( '/' )
	    self._curdir = self._root
	    self.getFileList('/')
	dlg.Destroy()
	
    # --------------------------------------------------------------------
    def OnClose( self, event ):
	self._ftp.close()
    
    # --------------------------------------------------------------------
    def getFileList( self, path ):
	self.flist.Clear()
	self._ftp.cwd( path )
	list = self._ftp.retrlines( 'LIST', self.addFile )
	self.tree.Expand( self._curdir )
	
    # --------------------------------------------------------------------
    def addFile( self, line ):
	info = string.split( line )
	fname = info[len(info)-1]
	if info[0][0] != 'd':
	    self.flist.Append( fname )
	elif len(fname) and fname != '..' :
	    item = self.tree.AppendItem( self._curdir, fname )
	
# ========================================================================
class mApp( wxApp ):
    def OnInit( self ):
	frame = wxFTP( test_menu )
	frame.Show(true)
	self.SetTopWindow(frame)
	return true

def main():
    app = mApp(0)
    app.MainLoop()
    
# ========================================================================
# ------------------------------------------------------------------------
if __name__ == '__main__':
    main()
